package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.SelfTakeService;
import com.gxwebsoft.shop.entity.SelfTake;
import com.gxwebsoft.shop.param.SelfTakeParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 自提点控制器
 *
 * @author 科技小王子
 * @since 2025-12-03 14:22:38
 */
@Api(tags = "自提点管理")
@RestController
@RequestMapping("/api/shop/self-take")
public class SelfTakeController extends BaseController {
    @Resource
    private SelfTakeService selfTakeService;

    @ApiOperation("分页查询自提点")
    @GetMapping("/page")
    public ApiResult<PageResult<SelfTake>> page(SelfTakeParam param) {
        // 使用关联查询
        return success(selfTakeService.pageRel(param));
    }

    @ApiOperation("查询全部自提点")
    @GetMapping()
    public ApiResult<List<SelfTake>> list(SelfTakeParam param) {
        // 使用关联查询
        return success(selfTakeService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:selfTake:list')")
    @ApiOperation("根据id查询自提点")
    @GetMapping("/{id}")
    public ApiResult<SelfTake> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(selfTakeService.getByIdRel(id));
    }

    @ApiOperation("添加自提点")
    @PostMapping()
    public ApiResult<?> save(@RequestBody SelfTake selfTake) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         selfTake.setUserId(loginUser.getUserId());
        }
        if (selfTakeService.save(selfTake)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改自提点")
    @PutMapping()
    public ApiResult<?> update(@RequestBody SelfTake selfTake) {
        if (selfTakeService.updateById(selfTake)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除自提点")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (selfTakeService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加自提点")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<SelfTake> list) {
        if (selfTakeService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改自提点")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<SelfTake> batchParam) {
        if (batchParam.update(selfTakeService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除自提点")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (selfTakeService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
